Index: pjproject/branches/projects/uwp/pjlib/include/pj/ssl_sock.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/ssl_sock.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/ssl_sock.h	(revision 5513)
@@ -181,4 +181,7 @@
     } subj_alt_name;		    /**< Subject alternative
 					 name extension		*/
+
+    pj_str_t raw;		    /**< Raw certificate in PEM format, only
+					 available for remote certificate. */
 
 } pj_ssl_cert_info;
@@ -399,4 +402,97 @@
 PJ_DECL(pj_ssl_cipher) pj_ssl_cipher_id(const char *cipher_name);
 
+/**
+ * Elliptic curves enumeration.
+ */
+typedef enum pj_ssl_curve
+{
+	PJ_TLS_UNKNOWN_CURVE 		= 0,
+	PJ_TLS_CURVE_SECT163K1		= 1,
+	PJ_TLS_CURVE_SECT163R1		= 2,
+	PJ_TLS_CURVE_SECT163R2		= 3,
+	PJ_TLS_CURVE_SECT193R1		= 4,
+	PJ_TLS_CURVE_SECT193R2		= 5,
+	PJ_TLS_CURVE_SECT233K1		= 6,
+	PJ_TLS_CURVE_SECT233R1		= 7,
+	PJ_TLS_CURVE_SECT239K1		= 8,
+	PJ_TLS_CURVE_SECT283K1		= 9,
+	PJ_TLS_CURVE_SECT283R1		= 10,
+	PJ_TLS_CURVE_SECT409K1		= 11,
+	PJ_TLS_CURVE_SECT409R1		= 12,
+	PJ_TLS_CURVE_SECT571K1		= 13,
+	PJ_TLS_CURVE_SECT571R1		= 14,
+	PJ_TLS_CURVE_SECP160K1		= 15,
+	PJ_TLS_CURVE_SECP160R1		= 16,
+	PJ_TLS_CURVE_SECP160R2		= 17,
+	PJ_TLS_CURVE_SECP192K1		= 18,
+	PJ_TLS_CURVE_SECP192R1		= 19,
+	PJ_TLS_CURVE_SECP224K1		= 20,
+	PJ_TLS_CURVE_SECP224R1		= 21,
+	PJ_TLS_CURVE_SECP256K1		= 22,
+	PJ_TLS_CURVE_SECP256R1		= 23,
+	PJ_TLS_CURVE_SECP384R1		= 24,
+	PJ_TLS_CURVE_SECP521R1		= 25,
+	PJ_TLS_CURVE_BRAINPOOLP256R1	= 26,
+	PJ_TLS_CURVE_BRAINPOOLP384R1	= 27,
+	PJ_TLS_CURVE_BRAINPOOLP512R1	= 28,
+	PJ_TLS_CURVE_ARBITRARY_EXPLICIT_PRIME_CURVES	= 0XFF01,
+	PJ_TLS_CURVE_ARBITRARY_EXPLICIT_CHAR2_CURVES	= 0XFF02
+} pj_ssl_curve;
+
+/**
+ * Get curve list supported by SSL/TLS backend.
+ *
+ * @param curves	The curves buffer to receive curve list.
+ * @param curves_num	Maximum number of curves to be received.
+ *
+ * @return		PJ_SUCCESS when successful.
+ */
+PJ_DECL(pj_status_t) pj_ssl_curve_get_availables(pj_ssl_curve curves[],
+					         unsigned *curve_num);
+
+/**
+ * Check if the specified curve is supported by SSL/TLS backend.
+ *
+ * @param curve		The curve.
+ *
+ * @return		PJ_TRUE when supported.
+ */
+PJ_DECL(pj_bool_t) pj_ssl_curve_is_supported(pj_ssl_curve curve);
+
+
+/**
+ * Get curve name string.
+ *
+ * @param curve		The curve.
+ *
+ * @return		The curve name or NULL if curve is not recognized/
+ *			supported.
+ */
+PJ_DECL(const char*) pj_ssl_curve_name(pj_ssl_curve curve);
+
+/**
+ * Get curve ID from curve name string. Note that on different backends
+ * (e.g. OpenSSL or Symbian implementation), curve names may not be
+ * equivalent for the same curve ID.
+ *
+ * @param curve_name	The curve name string.
+ *
+ * @return		The curve ID or PJ_TLS_UNKNOWN_CURVE if the curve
+ *			name string is not recognized/supported.
+ */
+PJ_DECL(pj_ssl_curve) pj_ssl_curve_id(const char *curve_name);
+
+/*
+ * Entropy enumeration
+ */
+typedef enum pj_ssl_entropy
+{
+	PJ_SSL_ENTROPY_NONE	= 0,
+	PJ_SSL_ENTROPY_EGD	= 1,
+	PJ_SSL_ENTROPY_RANDOM	= 2,
+	PJ_SSL_ENTROPY_URANDOM	= 3,
+	PJ_SSL_ENTROPY_FILE	= 4,
+	PJ_SSL_ENTROPY_UNKNOWN	= 0x0F
+} pj_ssl_entropy_t;
 
 /**
@@ -768,4 +864,49 @@
 
     /**
+     * Number of curves contained in the specified curve preference.
+     * If this is set to zero, then default curve list of the backend
+     * will be used.
+     *
+     * Default: 0 (zero).
+     */
+    unsigned curves_num;
+
+    /**
+     * Curves and order preference. The #pj_ssl_curve_get_availables()
+     * can be used to check the available curves supported by backend.
+     */
+    pj_ssl_curve *curves;
+
+    /**
+     * The supported signature algorithms. Set the sigalgs string
+     * using this form:
+     * "<DIGEST>+<ALGORITHM>:<DIGEST>+<ALGORITHM>"
+     * Digests are: "RSA", "DSA" or "ECDSA"
+     * Algorithms are: "MD5", "SHA1", "SHA224", "SHA256", "SHA384", "SHA512"
+     * Example: "ECDSA+SHA256:RSA+SHA256"
+     */
+    pj_str_t	sigalgs;
+
+    /**
+     * Reseed random number generator.
+     * For type #PJ_SSL_ENTROPY_FILE, parameter \a entropy_path
+     * must be set to a file.
+     * For type #PJ_SSL_ENTROPY_EGD, parameter \a entropy_path
+     * must be set to a socket.
+     *
+     * Default value is PJ_SSL_ENTROPY_NONE.
+    */
+    pj_ssl_entropy_t	entropy_type;
+
+    /**
+     * When using a file/socket for entropy #PJ_SSL_ENTROPY_EGD or
+     * #PJ_SSL_ENTROPY_FILE, \a entropy_path must contain the path
+     * to entropy socket/file.
+     *
+     * Default value is an empty string.
+     */
+    pj_str_t		entropy_path;
+
+    /**
      * Security negotiation timeout. If this is set to zero (both sec and 
      * msec), the negotiation doesn't have a timeout.
@@ -862,4 +1003,16 @@
  */
 PJ_DECL(void) pj_ssl_sock_param_default(pj_ssl_sock_param *param);
+
+
+/**
+ * Duplicate pj_ssl_sock_param.
+ *
+ * @param pool	Pool to allocate memory.
+ * @param dst	Destination parameter.
+ * @param src	Source parameter.
+ */
+PJ_DECL(void) pj_ssl_sock_param_copy(pj_pool_t *pool, 
+				     pj_ssl_sock_param *dst,
+				     const pj_ssl_sock_param *src);
 
 
@@ -1116,4 +1269,28 @@
 
 /**
+ * Same as #pj_ssl_sock_start_accept(), but application can provide
+ * a secure socket parameter, which will be used to create a new secure
+ * socket reported in \a on_accept_complete() callback when there is
+ * an incoming connection.
+ *
+ * @param ssock		The secure socket.
+ * @param pool		Pool used to allocate some internal data for the
+ *			operation.
+ * @param localaddr	Local address to bind on.
+ * @param addr_len	Length of buffer containing local address.
+ * @param newsock_param	Secure socket parameter for new accepted sockets.
+ *
+ * @return		PJ_SUCCESS if the operation has been successful,
+ *			or the appropriate error code on failure.
+ */
+PJ_DECL(pj_status_t)
+pj_ssl_sock_start_accept2(pj_ssl_sock_t *ssock,
+			  pj_pool_t *pool,
+			  const pj_sockaddr_t *local_addr,
+			  int addr_len,
+			  const pj_ssl_sock_param *newsock_param);
+
+
+/**
  * Starts asynchronous socket connect() operation and SSL/TLS handshaking 
  * for this socket. Once the connection is done (either successfully or not),
Index: pjproject/branches/projects/uwp/pjlib/include/pj/string.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/string.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/string.h	(revision 5513)
@@ -470,4 +470,6 @@
 PJ_INLINE(char*) pj_strchr( const pj_str_t *str, int chr)
 {
+    if (str->slen == 0)
+	return NULL;
     return (char*) memchr((char*)str->ptr, chr, str->slen);
 }
Index: pjproject/branches/projects/uwp/pjlib/include/pj/string_i.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib/include/pj/string_i.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/include/pj/string_i.h	(revision 5513)
@@ -19,4 +19,5 @@
  */
 
+#include <pj/assert.h>
 #include <pj/pool.h>
 
@@ -118,6 +119,8 @@
 			       pj_ssize_t max)
 {
+    pj_assert(max >= 0);
     if (max > src->slen) max = src->slen;
-    pj_memcpy(dst->ptr, src->ptr, max);
+    if (max > 0)
+	pj_memcpy(dst->ptr, src->ptr, max);
     dst->slen = max;
     return dst;
@@ -127,4 +130,6 @@
 					 pj_ssize_t max)
 {
+    pj_assert(max > 0);
+
     if (max <= src->slen)
 	max = max-1;
Index: pjproject/branches/projects/uwp/pjlib/src/pj/addr_resolv_sock.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/addr_resolv_sock.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/addr_resolv_sock.c	(revision 5513)
@@ -83,4 +83,6 @@
 		     af==PJ_AF_UNSPEC, PJ_EINVAL);
 
+#if PJ_WIN32_WINCE
+
     /* Check if nodename is IP address */
     pj_bzero(&ai[0], sizeof(ai[0]));
@@ -109,4 +111,8 @@
 	return PJ_SUCCESS;
     }
+
+#else /* PJ_WIN32_WINCE */
+    PJ_UNUSED_ARG(has_addr);
+#endif
 
     /* Copy node name to null terminated string. */
@@ -146,8 +152,8 @@
 		/* Store address */
 		addr_size = sizeof(*addr);
-		if (af == PJ_AF_INET6) {
+		if (addr->sa_family == PJ_AF_INET6) {
 		    addr_size = addr->sa_len;
 		}
-		PJ_ASSERT_ON_FAIL(addr_size <= sizeof(pj_sockaddr), 				  continue);
+		PJ_ASSERT_ON_FAIL(addr_size <= sizeof(pj_sockaddr), continue);
 		pj_memcpy(&ai[i].ai_addr, addr, addr_size);
 		PJ_SOCKADDR_RESET_LEN(&ai[i].ai_addr);
@@ -158,4 +164,7 @@
 	
 	*count = i;
+	if (*count == 0)
+	    status = PJ_ERESOLVE;
+
     } else {
 	status = PJ_ERESOLVE;
@@ -206,5 +215,5 @@
 
     /* Done */
-    return PJ_SUCCESS;
+    return (*count > 0? PJ_SUCCESS : PJ_ERESOLVE);
 #endif
 
@@ -213,4 +222,6 @@
 
     PJ_ASSERT_RETURN(count && *count, PJ_EINVAL);
+
+#if PJ_WIN32_WINCE
 
     /* Check if nodename is IP address */
@@ -241,4 +252,8 @@
 	return PJ_SUCCESS;
     }
+
+#else /* PJ_WIN32_WINCE */
+    PJ_UNUSED_ARG(has_addr);
+#endif
 
     if (af == PJ_AF_INET || af == PJ_AF_UNSPEC) {
@@ -274,5 +289,5 @@
 	}
 
-	return PJ_SUCCESS;
+	return (*count > 0? PJ_SUCCESS : PJ_ERESOLVE);
 
     } else {
Index: pjproject/branches/projects/uwp/pjlib/src/pj/config.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/config.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/config.c	(revision 5513)
@@ -51,5 +51,5 @@
 PJ_DEF(void) pj_dump_config(void)
 {
-    PJ_LOG(3, (id, "PJLIB (c)2008-2009 Teluu Inc."));
+    PJ_LOG(3, (id, "PJLIB (c)2008-2016 Teluu Inc."));
     PJ_LOG(3, (id, "Dumping configurations:"));
     PJ_LOG(3, (id, " PJ_VERSION                : %s", PJ_VERSION));
@@ -86,4 +86,5 @@
     PJ_LOG(3, (id, " PJ_OS_HAS_CHECK_STACK     : %d", PJ_OS_HAS_CHECK_STACK));
     PJ_LOG(3, (id, " PJ_HAS_HIGH_RES_TIMER     : %d", PJ_HAS_HIGH_RES_TIMER));
+    PJ_LOG(3, (id, " PJ_HAS_IPV6               : %d", PJ_HAS_IPV6));
 }
 
Index: pjproject/branches/projects/uwp/pjlib/src/pj/guid_android.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/guid_android.c	(revision 5513)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/guid_android.c	(revision 5513)
@@ -0,0 +1,117 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2015-2016 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+/* This original code was kindly contributed by Johan Lantz.
+ */
+#include <pj/guid.h>
+#include <pj/log.h>
+#include <pj/string.h>
+
+#include <jni.h>
+
+extern JavaVM *pj_jni_jvm;
+
+static pj_bool_t attach_jvm(JNIEnv **jni_env)
+{
+    if ((*pj_jni_jvm)->GetEnv(pj_jni_jvm, (void **)jni_env,
+                               JNI_VERSION_1_4) < 0)
+    {
+        if ((*pj_jni_jvm)->AttachCurrentThread(pj_jni_jvm, jni_env, NULL) < 0)
+        {
+            jni_env = NULL;
+            return PJ_FALSE;
+        }
+        return PJ_TRUE;
+    }
+    
+    return PJ_FALSE;
+}
+
+#define detach_jvm(attached) \
+    if (attached) \
+        (*pj_jni_jvm)->DetachCurrentThread(pj_jni_jvm);
+
+
+PJ_DEF_DATA(const unsigned) PJ_GUID_STRING_LENGTH=36;
+
+PJ_DEF(unsigned) pj_GUID_STRING_LENGTH()
+{
+    return PJ_GUID_STRING_LENGTH;
+}
+
+PJ_DEF(pj_str_t*) pj_generate_unique_string(pj_str_t *str)
+{
+    jclass uuid_class;
+    jmethodID get_uuid_method;
+    jmethodID to_string_method;
+    JNIEnv *jni_env = 0;
+    jobject javaUuid;
+    jstring uuid_string;
+    const char *native_string;
+    pj_str_t native_str;
+
+    pj_bool_t attached = attach_jvm(&jni_env);
+    if (!jni_env)
+        goto on_error;
+
+    uuid_class = (jclass)(*jni_env)->NewGlobalRef(jni_env,
+                 (*jni_env)->FindClass(jni_env, "java/util/UUID"));
+    if (uuid_class == 0)
+        goto on_error;
+
+    get_uuid_method = (*jni_env)->GetStaticMethodID(jni_env, uuid_class,
+                      "randomUUID",
+                      "()Ljava/util/UUID;");
+    if (get_uuid_method == 0)
+        goto on_error;
+
+    javaUuid = (*jni_env)->CallStaticObjectMethod(jni_env, uuid_class, 
+    						  get_uuid_method);
+    if (javaUuid == 0)
+        goto on_error;
+
+    to_string_method = (*jni_env)->GetMethodID(jni_env, uuid_class,
+    						"toString",
+    						"()Ljava/lang/String;");
+    if (to_string_method == 0)
+        goto on_error;
+
+    uuid_string = (*jni_env)->CallObjectMethod(jni_env, javaUuid,
+    					       to_string_method);
+    if (uuid_string == 0)
+        goto on_error;
+
+    native_string = (*jni_env)->GetStringUTFChars(jni_env, uuid_string,
+    						  JNI_FALSE);
+    if (native_string == 0)
+        goto on_error;
+
+    native_str.ptr = (char *)native_string;
+    native_str.slen = pj_ansi_strlen(native_string);
+    pj_strncpy(str, &native_str, PJ_GUID_STRING_LENGTH);
+
+    (*jni_env)->ReleaseStringUTFChars(jni_env, uuid_string, native_string);
+    detach_jvm(attached);
+
+    return str;
+
+on_error:
+    PJ_LOG(2, ("guid_android.c", ("Error generating UUID")));
+    detach_jvm(attached);
+    return NULL;
+}
Index: pjproject/branches/projects/uwp/pjlib/src/pj/hash.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/hash.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/hash.c	(revision 5513)
@@ -77,17 +77,4 @@
     long i;
 
-#if defined(PJ_HASH_USE_OWN_TOLOWER) && PJ_HASH_USE_OWN_TOLOWER != 0
-    for (i=0; i<key->slen; ++i) {
-	pj_uint8_t c = key->ptr[i];
-        char lower;
-	if (c & 64)
-	    lower = (char)(c | 32);
-	else
-	    lower = (char)c;
-	if (result)
-            result[i] = lower;
-	hval = hval * PJ_HASH_MULTIPLIER + lower;
-    }
-#else
     for (i=0; i<key->slen; ++i) {
         char lower = (char)pj_tolower(key->ptr[i]);
@@ -96,5 +83,4 @@
 	hval = hval * PJ_HASH_MULTIPLIER + lower;
     }
-#endif
 
     return hval;
Index: pjproject/branches/projects/uwp/pjlib/src/pj/os_core_unix.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/os_core_unix.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/os_core_unix.c	(revision 5513)
@@ -1126,5 +1126,5 @@
 #if (defined(PJ_LINUX) && PJ_LINUX!=0) || \
     defined(PJ_HAS_PTHREAD_MUTEXATTR_SETTYPE)
-	rc = pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_FAST_NP);
+	rc = pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_NORMAL);
 #elif (defined(PJ_RTEMS) && PJ_RTEMS!=0) || \
        defined(PJ_PTHREAD_MUTEXATTR_T_HAS_RECURSIVE)
@@ -1136,5 +1136,5 @@
 #if (defined(PJ_LINUX) && PJ_LINUX!=0) || \
      defined(PJ_HAS_PTHREAD_MUTEXATTR_SETTYPE)
-	rc = pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE_NP);
+	rc = pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
 #elif (defined(PJ_RTEMS) && PJ_RTEMS!=0) || \
        defined(PJ_PTHREAD_MUTEXATTR_T_HAS_RECURSIVE)
Index: pjproject/branches/projects/uwp/pjlib/src/pj/os_time_common.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/os_time_common.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/os_time_common.c	(revision 5513)
@@ -29,17 +29,22 @@
 PJ_DEF(pj_status_t) pj_time_decode(const pj_time_val *tv, pj_parsed_time *pt)
 {
-    struct tm *local_time;
+    struct tm local_time;
 
     PJ_CHECK_STACK();
 
-    local_time = localtime((time_t*)&tv->sec);
+#if defined(PJ_HAS_LOCALTIME_R) && PJ_HAS_LOCALTIME_R != 0
+    localtime_r((time_t*)&tv->sec, &local_time);
+#else
+    /* localtime() is NOT thread-safe. */
+    local_time = *localtime((time_t*)&tv->sec);
+#endif
 
-    pt->year = local_time->tm_year+1900;
-    pt->mon = local_time->tm_mon;
-    pt->day = local_time->tm_mday;
-    pt->hour = local_time->tm_hour;
-    pt->min = local_time->tm_min;
-    pt->sec = local_time->tm_sec;
-    pt->wday = local_time->tm_wday;
+    pt->year = local_time.tm_year+1900;
+    pt->mon = local_time.tm_mon;
+    pt->day = local_time.tm_mday;
+    pt->hour = local_time.tm_hour;
+    pt->min = local_time.tm_min;
+    pt->sec = local_time.tm_sec;
+    pt->wday = local_time.tm_wday;
     pt->msec = tv->msec;
 
Index: pjproject/branches/projects/uwp/pjlib/src/pj/os_timestamp_posix.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/os_timestamp_posix.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/os_timestamp_posix.c	(revision 5513)
@@ -161,4 +161,66 @@
 }
 
+#elif defined(__ANDROID__)
+
+#include <errno.h>
+#include <linux/android_alarm.h>
+#include <fcntl.h>
+#include <time.h>
+
+#define NSEC_PER_SEC	1000000000
+
+static int s_alarm_fd = -1;
+
+void close_alarm_fd()
+{
+    if (s_alarm_fd != -1)
+	close(s_alarm_fd);
+    s_alarm_fd = -1;
+}
+
+PJ_DEF(pj_status_t) pj_get_timestamp(pj_timestamp *ts)
+{
+    struct timespec tp;
+    int err = -1;
+
+    if (s_alarm_fd == -1) {
+        int fd = open("/dev/alarm", O_RDONLY);
+        if (fd >= 0) {
+	    s_alarm_fd = fd;
+	    pj_atexit(&close_alarm_fd);
+        }
+    }
+    
+    if (s_alarm_fd != -1) {
+        err = ioctl(s_alarm_fd,
+              ANDROID_ALARM_GET_TIME(ANDROID_ALARM_ELAPSED_REALTIME), &tp);
+    }
+    
+    if (err != 0) {
+    	/* Fallback to CLOCK_MONOTONIC if /dev/alarm is not found, or
+    	 * getting ANDROID_ALARM_ELAPSED_REALTIME fails.
+    	 */
+        err = clock_gettime(CLOCK_MONOTONIC, &tp);
+    }
+
+    if (err != 0) {
+	return PJ_RETURN_OS_ERROR(pj_get_native_os_error());
+    }
+
+    ts->u64 = tp.tv_sec;
+    ts->u64 *= NSEC_PER_SEC;
+    ts->u64 += tp.tv_nsec;
+
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(pj_status_t) pj_get_timestamp_freq(pj_timestamp *freq)
+{
+    freq->u32.hi = 0;
+    freq->u32.lo = NSEC_PER_SEC;
+
+    return PJ_SUCCESS;
+}
+
 #elif defined(USE_POSIX_TIMERS) && USE_POSIX_TIMERS != 0
 #include <sys/time.h>
Index: pjproject/branches/projects/uwp/pjlib/src/pj/sock_bsd.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/sock_bsd.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/sock_bsd.c	(revision 5513)
@@ -132,4 +132,12 @@
 
 
+/* IPV6_TCLASS */
+#ifdef IPV6_TCLASS
+const pj_uint16_t PJ_IPV6_TCLASS = IPV6_TCLASS;
+#else
+const pj_uint16_t PJ_IPV6_TCLASS = 0xFFFF;
+#endif
+
+
 /* optname values. */
 const pj_uint16_t PJ_SO_TYPE    = SO_TYPE;
@@ -540,4 +548,10 @@
 			       &val, sizeof(val));
 	}
+#if defined(PJ_SOCK_HAS_IPV6_V6ONLY) && PJ_SOCK_HAS_IPV6_V6ONLY != 0
+	if (af == PJ_AF_INET6) {
+	    pj_sock_setsockopt(*sock, PJ_SOL_IPV6, IPV6_V6ONLY,
+			       &val, sizeof(val));
+	}
+#endif
 #if defined(PJ_IPHONE_OS_HAS_MULTITASKING_SUPPORT) && \
     PJ_IPHONE_OS_HAS_MULTITASKING_SUPPORT!=0
Index: pjproject/branches/projects/uwp/pjlib/src/pj/sock_common.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/sock_common.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/sock_common.c	(revision 5513)
@@ -173,6 +173,10 @@
 
     if (str_addr && str_addr->slen) {
+#if defined(PJ_SOCKADDR_USE_GETADDRINFO) && PJ_SOCKADDR_USE_GETADDRINFO!=0
+	if (1) {
+#else
 	status = pj_inet_pton(PJ_AF_INET6, str_addr, &addr->ipv6.sin6_addr);
 	if (status != PJ_SUCCESS) {
+#endif
     	    pj_addrinfo ai;
 	    unsigned count = 1;
@@ -182,4 +186,5 @@
 		pj_memcpy(&addr->ipv6.sin6_addr, &ai.ai_addr.ipv6.sin6_addr,
 			  sizeof(addr->ipv6.sin6_addr));
+		addr->ipv6.sin6_scope_id = ai.ai_addr.ipv6.sin6_scope_id;
 	    }
 	}
@@ -1245,4 +1250,9 @@
 }
 
+PJ_DEF(int) pj_IPV6_TCLASS(void)
+{
+    return PJ_IPV6_TCLASS;
+}
+
 PJ_DEF(pj_uint16_t) pj_SO_TYPE(void)
 {
Index: pjproject/branches/projects/uwp/pjlib/src/pj/sock_qos_bsd.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/sock_qos_bsd.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/sock_qos_bsd.c	(revision 5513)
@@ -23,5 +23,5 @@
 
 /* This is the implementation of QoS with BSD socket's setsockopt(),
- * using IP_TOS and SO_PRIORITY
+ * using IP_TOS/IPV6_TCLASS and SO_PRIORITY
  */ 
 #if !defined(PJ_QOS_IMPLEMENTATION) || PJ_QOS_IMPLEMENTATION==PJ_QOS_BSD
@@ -42,8 +42,28 @@
     /* Set TOS/DSCP */
     if (param->flags & PJ_QOS_PARAM_HAS_DSCP) {
+	/* We need to know if the socket is IPv4 or IPv6 */
+	pj_sockaddr sa;
+	int salen = sizeof(salen);
+
 	/* Value is dscp_val << 2 */
 	int val = (param->dscp_val << 2);
-	status = pj_sock_setsockopt(sock, pj_SOL_IP(), pj_IP_TOS(), 
-				    &val, sizeof(val));
+
+	status = pj_sock_getsockname(sock, &sa, &salen);
+	if (status != PJ_SUCCESS)
+	    return status;
+
+	if (sa.addr.sa_family == pj_AF_INET()) {
+	    /* In IPv4, the DS field goes in the TOS field */
+	    status = pj_sock_setsockopt(sock, pj_SOL_IP(), pj_IP_TOS(), 
+					&val, sizeof(val));
+	} else if (sa.addr.sa_family == pj_AF_INET6()) {
+	    /* In IPv6, the DS field goes in the Traffic Class field */
+	    status = pj_sock_setsockopt(sock, pj_SOL_IPV6(),
+					pj_IPV6_TCLASS(),
+					&val, sizeof(val));
+	} else {
+	    status = PJ_EINVAL;
+	}
+
 	if (status != PJ_SUCCESS) {
 	    param->flags &= ~(PJ_QOS_PARAM_HAS_DSCP);
@@ -85,4 +105,6 @@
     pj_status_t last_err = PJ_ENOTSUP;
     int val, optlen;
+    pj_sockaddr sa;
+    int salen = sizeof(salen);
     pj_status_t status;
 
@@ -90,10 +112,24 @@
 
     /* Get DSCP/TOS value */
-    optlen = sizeof(val);
-    status = pj_sock_getsockopt(sock, pj_SOL_IP(), pj_IP_TOS(), 
-				&val, &optlen);
+    status = pj_sock_getsockname(sock, &sa, &salen);
     if (status == PJ_SUCCESS) {
-	p_param->flags |= PJ_QOS_PARAM_HAS_DSCP;
-	p_param->dscp_val = (pj_uint8_t)(val >> 2);
+	optlen = sizeof(val);
+	if (sa.addr.sa_family == pj_AF_INET()) {
+	    status = pj_sock_getsockopt(sock, pj_SOL_IP(), pj_IP_TOS(), 
+					&val, &optlen);
+	} else if (sa.addr.sa_family == pj_AF_INET6()) {
+	    status = pj_sock_getsockopt(sock, pj_SOL_IPV6(),
+					pj_IPV6_TCLASS(),
+					&val, &optlen);
+	} else {
+	    status = PJ_EINVAL;
+	}
+
+        if (status == PJ_SUCCESS) {
+    	    p_param->flags |= PJ_QOS_PARAM_HAS_DSCP;
+	    p_param->dscp_val = (pj_uint8_t)(val >> 2);
+	} else {
+	    last_err = status;
+	}
     } else {
 	last_err = status;
Index: pjproject/branches/projects/uwp/pjlib/src/pj/sock_qos_common.c
===================================================================
--- pjproject/branches/projects/uwp/pjlib/src/pj/sock_qos_common.c	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib/src/pj/sock_qos_common.c	(revision 5513)
@@ -32,8 +32,9 @@
     /* flags	dscp  prio wmm_prio */
     {ALL_FLAGS, 0x00, 0,    PJ_QOS_WMM_PRIO_BULK_EFFORT},   /* BE */
-    {ALL_FLAGS, 0x08, 2,    PJ_QOS_WMM_PRIO_BULK},	    /* BK */
+    {ALL_FLAGS, 0x08, 2,    PJ_QOS_WMM_PRIO_BULK},	    /* BK */    
     {ALL_FLAGS, 0x28, 5,    PJ_QOS_WMM_PRIO_VIDEO},	    /* VI */
     {ALL_FLAGS, 0x30, 6,    PJ_QOS_WMM_PRIO_VOICE},	    /* VO */
-    {ALL_FLAGS, 0x38, 7,    PJ_QOS_WMM_PRIO_VOICE}	    /* CO */
+    {ALL_FLAGS, 0x38, 7,    PJ_QOS_WMM_PRIO_VOICE},	    /* CO */
+    {ALL_FLAGS, 0x28, 5,    PJ_QOS_WMM_PRIO_VIDEO}	    /* SIG */
 };
 
